$(document).ready(function() {
    $('.deleteFileReferenceLink').click(function(e) {
        e.preventDefault();

        var $parent = $(this).parent();
        var $image = $parent.find('img');
        var $hiddenField = $('#imagesToDelete-' + $(this).data('fileReference'));

        $hiddenField.val($(this).data('fileReference'));
        $parent.remove();
    });
});

if($('.dp-form-slug').length) {
    $('.dp-form-slug .icon').on('click', function(e) {
        var $dpFormSlug = $(this).parents('.dp-form-slug');
        var $slugField = $dpFormSlug.find('input[type="text"]');
        var slugSuggestUrl = $slugField.data('slugSuggestUrl');
        var $form = $dpFormSlug.parents('form');
        var data = $form.serialize();

        /*var newPluginName = 'tx_igruckzuckevent_slugsuggest';
        data = data.replace(/tx_igruckzuckevent_eventmanagement/g, newPluginName)
            .replace(/tx_igruckzuckevent_eventsinprocessing/g, newPluginName)
            .replace(/tx_igruckzuckevent_eventsarchive/g, newPluginName)
            .replace(/newEvent/g, 'event');*/
        var identity = '';
        if($('.event-form input[type="hidden"][name*="__identity"]').length) {
            identity = $('.event-form input[type="hidden"][name*="__identity"]').val();
        }

        var data = {
            tx_igruckzuckevent_slugsuggest: {
                event: {
                    title: $('.event-form #title').val(),
                    coursNo: $('.event-form #coursNo').val(),
                },
                __trustedProperties: $('.event-form input[type="hidden"][name*="__trustedProperties"]').val()
            }
        };

        if(identity) {
            data.tx_igruckzuckevent_slugsuggest.event.__identity = identity;
        }

        $.ajax({
            url: slugSuggestUrl,
            method: 'POST',
            data: data,
            success: function(data) {
                $slugField.click();
                $slugField.val(data.slug);
            }
        })
    });
}

// Validation Kursanmeldung
if ($('.tx-ig-ruckzuckevent #registrationForm').length > 0) {
    // Switch tab in registration form
    function switchTab(tab) {
        $('.tx-ig-ruckzuckevent #registrationForm .tabMenu .tabLink').removeClass('active');
        $('.tx-ig-ruckzuckevent #registrationForm .tabMenu .tabLink.' + tab + '-link').addClass('active');

        $('.tx-ig-ruckzuckevent #registrationForm .tab').removeClass('show');
        $('.tx-ig-ruckzuckevent #registrationForm .' + tab).addClass('show');
    }

    // Switch to tab with first error in registration form
    function switchToErrorTab() {
        switchTab($('.tx-ig-ruckzuckevent #registrationForm .error:first').closest('.tab').data('tab'));
    }

    // Validation of form elements before tab switch and submit
    function validateBeforeTabSwitch(tab) {
        var isFormValid = true;

        var $tabsToCheck = $('.tx-ig-ruckzuckevent #registrationForm .' + tab).prevAll().not($('.' + tab)).addBack();
        $tabsToCheck.find('.registration-validate').each(function() {
            if ($(this).val() != '') {
                $(this).removeClass('error');
            } else {
                $(this).addClass('error');
                isFormValid = false;
            }
        });

        $tabsToCheck.find('.registration-validate-checkbox').each(function() {
            var isChecked = false;

            if ($(this).find('input[type="checkbox"]:checked,input[type="radio"]:checked').length) {
                isChecked = true;
            }

            if (!isChecked) {
                $(this).addClass('error');
                isFormValid = false;
            } else {
                $(this).removeClass('error');
            }
        });


        if ($('#registration-email').val() != '') {
            var emailRegex = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;

            if (emailRegex.test($('#registration-email').val())) {
                $('#registration-email').removeClass('error');
            } else {
                $('#registration-email').addClass('error');
                isFormValid = false;
            }
        } else if ($('#registration-email').hasClass('registration-validate')) {
            $('#registration-email').addClass('error');
        } else {
            $('#registration-email').removeClass('error');
        }
        return isFormValid;
    }

    // Validation on submit of registration form
    // $('.tx-ig-ruckzuckevent #registrationForm').submit(function(e) {
    //     var $lastTab = $('.tx-ig-ruckzuckevent #registrationForm .tab:last');
    //     if(!$lastTab.hasClass('show')) {
    //         e.preventDefault();
    //         return;
    //     }
    //
    //     var isFormValid = validateBeforeTabSwitch($lastTab.data('tab'));
    //
    //     if($('#registration-bill').length) {
    //         if($('#registration-bill').val() != '') {
    //             $('#registration-bill').removeClass('error');
    //         } else {
    //             $('#registration-bill').addClass('error');
    //             isFormValid = false;
    //         }
    //     }
    //
    //     if($('.registration-status').parents('.multiple.validate').length) {
    //         if($('.registration-status:checked').length > 0) {
    //             $('.registration-status').parent().parent().parent().parent().removeClass('error');
    //         } else {
    //             $('.registration-status').parent().parent().parent().parent().addClass('error');
    //             isFormValid = false;
    //         }
    //     }
    //
    //     if($('#registration-accept-1').length) {
    //         if($('#registration-accept-1').is(':checked')) {
    //             $('#registration-accept-1').parent().parent().parent().parent().removeClass('error');
    //         } else {
    //             $('#registration-accept-1').parent().parent().parent().parent().addClass('error');
    //             isFormValid = false;
    //         }
    //     }
    //
    //     if($('#sjbr-freecap-captcha-response').val() != '') {
    //         $('#sjbr-freecap-captcha-response').removeClass('error');
    //     } else {
    //         $('#sjbr-freecap-captcha-response').addClass('error');
    //         isFormValid = false;
    //     }
    //
    //     if(!isFormValid) {
    //         e.preventDefault();
    //         switchToErrorTab();
    //     }
    // });
    function registrationFormOnSubmit() {
        var $lastTab = $('.tx-ig-ruckzuckevent #registrationForm .tab:last');
        if (!$lastTab.hasClass('show')) {
            e.preventDefault();
            return;
        }

        var isFormValid = validateBeforeTabSwitch($lastTab.data('tab'));

        if ($('#registration-bill').length) {
            if ($('#registration-bill').val() != '') {
                $('#registration-bill').removeClass('error');
            } else {
                $('#registration-bill').addClass('error');
                isFormValid = false;
            }
        }

        if ($('.registration-status').parents('.multiple.validate').length) {
            if ($('.registration-status:checked').length > 0) {
                $('.registration-status').parent().parent().parent().parent().removeClass('error');
            } else {
                $('.registration-status').parent().parent().parent().parent().addClass('error');
                isFormValid = false;
            }
        }

        if ($('#registration-accept-1').length) {
            if ($('#registration-accept-1').is(':checked')) {
                $('#registration-accept-1').parent().parent().parent().parent().removeClass('error');
            } else {
                $('#registration-accept-1').parent().parent().parent().parent().addClass('error');
                isFormValid = false;
            }
        }

        if ($('#sjbr-freecap-captcha-response').val() != '') {
            $('#sjbr-freecap-captcha-response').removeClass('error');
        } else {
            $('#sjbr-freecap-captcha-response').addClass('error');
            isFormValid = false;
        }

        if (grecaptcha.getResponse() === '') {
            isFormValid = false;
        }


        if (!isFormValid) {
            switchToErrorTab();
            return;
        } else {
            // no captcha
            $('.tx-ig-ruckzuckevent #registrationForm').submit();
            return;
        }
    }

    // Handle validation on tab switch
    $('.tx-ig-ruckzuckevent #registrationForm .tabLink').click(function() {
        if (validateBeforeTabSwitch($(this).data('tab'))) {
            switchTab($(this).data('tab'));
        } else {
            switchToErrorTab();
        }
    });

    // Jump to tab with first error on load if errors are in the registration form
    if ($('.tx-ig-ruckzuckevent #registrationForm .error').length > 0) {
        switchToErrorTab();
    }
    if ($('#registration-bill').length) {
        if ($('#registration-bill').val() == 1) {
            $('.tab2 input[type="text"]').addClass('registration-validate');
            $('.tab2 input[type="text"]').each(function() {
                var $label = $(this).siblings('label');
                $label.text($label.text() + ' *')
            });
        }
        $('#registration-bill').on('change', function(e) {
            if ($(this).val() == 1) {
                $('.tab2 input[type=text]').addClass('registration-validate');
                $('.tab2 input[type=text]').each(function() {
                    var $label = $(this).siblings('label');
                    $label.text($label.text() + ' *');
                });
            } else {
                $('.tab2 input[type=text]').removeClass('registration-validate');
                $('.tab2 input[type=text]').each(function() {
                    var $label = $(this).siblings('label');
                    //console.log($label.text().indexOf('*'));
                    var indexOfAsterik = $label.text().indexOf('*');
                    $label.text($label.text().substr(0, indexOfAsterik === -1 ? $label.text().length : indexOfAsterik - 1));
                });
            }
        });
    }
}

if($('.public-event').length) {
    $('.public-event').on('submit', function(e) {
        var form = $(this).get(0);
        if (!form.checkValidity()) {
            form.reportValidity();
            e.preventDefault();
        }
        if (grecaptcha.getResponse() === "") {
            e.preventDefault();
        }
    });
    function publicEventOnSubmit() {
        $('.public-event').trigger('submit');
    }
}

if($('.dp-form.event-form').length) {
    if($('.ig-tabs-tab .error').length) {
        $('.ig-tabs-tab .error').each(function() {
            $('.ig-tabs-menu-item[data-tab-name="' + $(this).parents('.ig-tabs-tab').data('tab-name') + '"]').addClass('ig-tabs-tab-error');
        });
    }
}
